'
'	ff_pb_url.bas
'

%CHAR_A = 65
%CHAR_z = 122
%CHAR_0 = 48
%CHAR_9 = 57

Global g_url_Return as String

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  urlEncode
'
'  url encodes a string
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function urlEncode Alias "urlEncode" _
      (ByVal incoming as String) Export as String

   Dim i as Long
   Dim b_in as Byte Ptr
   Dim sOut as String


   b_in = strptr(incoming)
   For i = 1 to len(incoming)
      if ((@b_in < %CHAR_A) or (@b_in > %CHAR_Z)) and _
         ((@b_in < %CHAR_0) or (@b_in > %CHAR_9)) then
         sOut = sOut + "%" + Right$("0" + hex$(@b_in), 2)
      else
         sOut = sOut + chr$(@b_in)
      end if
      incr b_in
   Next i

   Function = sOut

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  urlzEncode
'
'  url encodes a string
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function urlzEncode Alias "urlzEncode" _
      (incoming as Asciiz) Export as Dword

   g_url_Return = urlEncode( (incoming) ) + $nul
   Function = strptr(g_url_Return)

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  urlDecode
'
'  Decodes the cgi parameter encoding
'  This is Power Basic's pbcgi.inc files DecodeCGI function. I renamed
'  it here so it's easier to include.
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function urlDecode Alias "urlDecode" (ByVal t As String) export as string

  Dim b_in  As Byte Ptr
  Dim b_out As Byte Ptr
  Dim h     As String Ptr * 2
  Dim a     As Asciiz Ptr

  If Len(t) = 0 Then
    Exit Function
  End If

  b_in  = StrPtr(t)
  b_out = b_in

  Do

    If @b_in = 43 Then          'convert plus to space
      @b_out = 32

    ElseIf @b_in = 37 Then      'process special chars

      '- Check for a % as the
      '  last character. This
      '  shouldn't happen, ever.
      '
      h = b_in + 1
      @b_out = Val("&H" + @h)
      incr b_in
      incr b_in

    Else
      @b_out = @b_in

    End If

    Incr b_in
    Incr b_out

  Loop Until @b_in = 0

  @b_out = 0

  a = StrPtr(t)

  Function = @a

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'  urlzDecode
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function urlzDecode Alias "urlzDecode" _
      ( zIncoming as asciiz ) export as dword

   g_url_Return = urlDecode( (zincoming) ) + $nul
   Function = strptr(g_url_Return)

end function
